// we just export the symbols we need from here:

#include <vector>
#include <sstream>

// #define BOOST_TEST_MODULE "NervSeed tests"
// // #define BOOST_TEST_NO_MAIN
// #define BOOST_TEST_ALTERNATIVE_INIT_API
// #include <boost/test/included/unit_test.hpp>
// #include <boost/test/test_tools.hpp>
// #include <iostream>

// #define BOOST_TEST_SOURCE
// #include <boost/test/impl/unit_test_main.ipp>

// Helper module used to re-export the missing symbols that may be needed in LLVM JIT code.
#pragma comment(linker, "/export:??3@YAXPEAX_K@Z")
#pragma comment(linker, "/export:??2@YAPEAX_K@Z")
#pragma comment(linker, "/export:??3@YAXPEAX@Z")
#pragma comment(linker, "/export:??_7type_info@@6B@")

#pragma comment(linker, "/export:_Init_thread_header")
#pragma comment(linker, "/export:_Init_thread_footer")
#pragma comment(linker, "/export:_Init_thread_abort")
#pragma comment(linker, "/export:_tls_index")
#pragma comment(linker, "/export:_Init_thread_epoch")

#pragma comment(linker, "/export:?_Facet_Register@std@@YAXPEAV_Facet_base@1@@Z")
#pragma comment(linker, "/export:??2@YAPEAX_KAEBUnothrow_t@std@@@Z")
#pragma comment(linker, "/export:?nothrow@std@@3Unothrow_t@1@B")
// #pragma comment(linker, "/export:atexit")

#pragma comment(linker, "/export:__security_check_cookie")
#pragma comment(linker, "/export:__security_cookie")


#pragma comment(linker, "/export:?__type_info_root_node@@3U__type_info_node@@A")
#pragma comment(linker, "/export:??_V@YAXPEAX@Z")

// symbols from boost test framework:
// #pragma comment(linker, "/export:?test_finish@unit_test_log_t@unit_test@boost@@UEAAXXZ")
// #pragma comment(linker, "/export:?report_assertion@tt_detail@test_tools@boost@@YA_NAEBVassertion_result@23@AEBVlazy_ostream@unit_test@3@V?$basic_cstring@$$CBD@63@_KW4tool_level@123@W4check_type@123@3ZZ")
// #pragma comment(linker, "/export:?normalize_test_case_name@ut_detail@unit_test@boost@@YA?AV?$basic_string@DU?$char_traits@D@std@@V?$allocator@D@2@@std@@V?$basic_cstring@$$CBD@23@@Z")
// #pragma comment(linker, "/export:?unit_test_main@unit_test@boost@@YAHP6A_NXZHQEAPEAD@Z")
// #pragma comment(linker, "/export:?test_aborted@unit_test_log_t@unit_test@boost@@UEAAXXZ")
// #pragma comment(linker, "/export:??0auto_test_unit_registrar@ut_detail@unit_test@boost@@QEAA@PEAVtest_case@23@AEAVcollector@decorator@23@K@Z")
// #pragma comment(linker, "/export:??0auto_test_unit_registrar@ut_detail@unit_test@boost@@QEAA@V?$basic_cstring@$$CBD@23@0_KAEAVcollector@decorator@23@@Z")
// #pragma comment(linker, "/export:??0test_case@unit_test@boost@@QEAA@V?$basic_cstring@$$CBD@12@0_KAEBV?$function@$$A6AXXZ@2@@Z")
// #pragma comment(linker, "/export:?master_test_suite@framework@unit_test@boost@@YAAEAVmaster_test_suite_t@23@XZ")
// #pragma comment(linker, "/export:?test_start@unit_test_log_t@unit_test@boost@@UEAAXK@Z")
// #pragma comment(linker, "/export:?test_unit_aborted@unit_test_log_t@unit_test@boost@@UEAAXAEBVtest_unit@23@@Z")
// #pragma comment(linker, "/export:?set_checkpoint@unit_test_log_t@unit_test@boost@@QEAAXV?$basic_cstring@$$CBD@23@_K0@Z")
// #pragma comment(linker, "/export:?test_unit_finish@unit_test_log_t@unit_test@boost@@UEAAXAEBVtest_unit@23@K@Z")
// #pragma comment(linker, "/export:?test_unit_skipped@unit_test_log_t@unit_test@boost@@UEAAXAEBVtest_unit@23@V?$basic_cstring@$$CBD@23@@Z")
// #pragma comment(linker, "/export:?exception_caught@unit_test_log_t@unit_test@boost@@UEAAXAEBVexecution_exception@3@@Z")
// #pragma comment(linker, "/export:?test_unit_start@unit_test_log_t@unit_test@boost@@UEAAXAEBVtest_unit@23@@Z")
// #pragma comment(linker, "/export:run_boost_tests")


// void make_use_of(char**)
// {
//   std::cout << "Using custom entry point..." << std::endl;
// }

// extern "C" int run_boost_tests(int argc, char* argv[], char* envp[])
// {
//   make_use_of(envp);
//   return boost::unit_test::unit_test_main(init_unit_test, argc, argv);
// }

// #pragma comment(linker, "/export:?unit_test_main@unit_test@boost@@YAHP6A_NXZHQEAPEAD@Z")

// symbols from kernel32:
// #pragma comment(linker, "/export:AddVectoredExceptionHandler")
// #pragma comment(linker, "/export:GetConsoleScreenBufferInfo")
// #pragma comment(linker, "/export:GetStdHandle")
// #pragma comment(linker, "/export:IsDebuggerPresent")
// #pragma comment(linker, "/export:__chkstk")
// #pragma comment(linker, "/export:OutputDebugStringA")
// #pragma comment(linker, "/export:RemoveVectoredExceptionHandler")
// #pragma comment(linker, "/export:SetConsoleTextAttribute")
// #pragma comment(linker, "/export:SetThreadStackGuarantee")

// #pragma comment(linker, "/export:__emutls_v._Init_thread_epoch")
// #pragma comment(linker, "/export:__emutls_get_address")

