#ifndef LLVM_COMMON_
#define LLVM_COMMON_

#include <llvm_exports.h>

#include <memory>
#include <set>
#include <string>
#include <sstream>
#include <vector>
#include <map>
#include <iostream>
#include <string>

namespace nv {

NVLLVM_EXPORT void initLLVM();
NVLLVM_EXPORT void uninitLLVM();

typedef std::vector<std::string> FileList;

}

NVLLVM_EXPORT void runClang(const nv::FileList& files);

#endif
